from .qpms_cdefs cimport qpms_finite_group_t, qpms_scatsys_t, qpms_iri_t,\
     qpms_scatsys_at_omega_t, qpms_scatsys_at_omega_k_t
from .cymaterials cimport EpsMuGenerator

cdef class FinitePointGroup:
    cdef readonly bint owns_data
    cdef qpms_finite_group_t *G

    cdef inline qpms_finite_group_t *rawpointer(self):
        return self.G


cdef class ScatteringSystem:
    cdef list tmgobjs # here we keep the references to occuring TMatrixFunctions (and hence BaseSpecs and TMatrixGenerators)
    #cdef list Tmatrices # Here we keep the references to occuring T-matrices
    cdef EpsMuGenerator medium_holder # Here we keep the reference to medium generator
    cdef qpms_scatsys_t *s
    cdef FinitePointGroup sym

    cdef qpms_iri_t iri_py2c(self, iri, allow_None=?)


cdef class _ScatteringSystemAtOmegaK:
    cdef qpms_scatsys_at_omega_k_t sswk
    cdef _ScatteringSystemAtOmega ssw_pyref

    cdef inline qpms_scatsys_at_omega_k_t *rawpointer(self):
        return &self.sswk


cdef class _ScatteringSystemAtOmega:
    cdef qpms_scatsys_at_omega_t *ssw
    cdef ScatteringSystem ss_pyref
    
    cdef inline qpms_scatsys_at_omega_t *rawpointer(self):
        return self.ssw
 
